#include <iostream>
using namespace std;

int main()
{
    int n,m;
    cin >> n >> m;
    int a[n],b[n],t[n];
    for(int i=0;i<m;i++)
    {
        cin >> a[i] >> b[i] >> t[i];
    }
    int mika, laza;
    cin >> mika >> laza;
    /*
    int suma=0,masina=0;
    for(int i=0;i<m;i++)
    {
        if(a[i]==mika)
        {
            for(int j=0;j<m;j++)
            {
                if(b[i]==a[j] && t[i]!=t[j])
                {
                    masina++;

                    if(b[j]==laza)return 0;

                }
            }
        }
    }
    */
    
    cout << "-1";
    return 0;
}